#!/bin/bash

# path to watch
__APPVEYOR_SHELL_ID=$1
__appveyor_pipe_in="/tmp/${__APPVEYOR_SHELL_ID}-in"
__appveyor_pipe_out="/tmp/${__APPVEYOR_SHELL_ID}-out"
__APPVEYOR_BIN_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
__APPVEYOR_END_COMMAND='\x17\x17\x17\x17\x17'

function __appveyor_print_command_end () {

	printf "$__APPVEYOR_END_COMMAND"

	if [ "$APPVEYOR_CONSOLE_DISABLE_PTY" = "true" ]
	then
		(>&2 printf "$__APPVEYOR_END_COMMAND")
	fi
}

function __appveyor_print_result () {

    pwd
    printenv
    echo "--- end env ---"
    echo "$1"

}

#echo "PIPE: $__appveyor_pipe_in"

mode="cd"
while true; do
    if read -r __appveyor_line; then
        case ${mode} in
            cd )
				__appveyor_cmd=""
                #echo "CD LINE: $__appveyor_line"
                cd "$__appveyor_line"
                mode="env"
                ;;
            env )
                if [[ "$__appveyor_line" = "--- end env ---" ]]; then
                    mode="cmd"
                else
                    #echo "ENV LINE: $__appveyor_line"
                    __appveyor_value=${__appveyor_line#*=}
                    __appveyor_key=${__appveyor_line%%=*}
                    if [[ ${#__appveyor_key} -gt 0 ]]; then
                        eval "export ${__appveyor_key}=\""${__appveyor_value}"\""
                    fi
                fi
                ;;
            cmd )
                if [[ "$__appveyor_line" = "--- end cmd ---" ]]; then
                    # save state
                    set_builtins=$(set -o)

                    eval "$__appveyor_cmd"
                    __appveyor_result=$?

                    # restore
                    set +o xtrace
                    while read -r BUILT STATUS; do
                        if [ "$STATUS" == "on" ]; then
                            set -o $BUILT
                        else
                            set +o $BUILT
                        fi;
                    done <<< "$set_builtins"    

                    # send results
                    __appveyor_print_result $__appveyor_result > "$__appveyor_pipe_out"

                    # the end of output
                    __appveyor_print_command_end

                    mode='cd'
                else
                    #echo "CMD LINE: $__appveyor_line"
                    __appveyor_cmd="$__appveyor_cmd
$__appveyor_line"
                fi
                ;;
        esac
    fi
done < "$__appveyor_pipe_in"